    Program f01fkfe

!     F01FKF Example Program Text

!     Mark 24 Release. NAG Copyright 2012.

!     .. Use Statements ..
      Use nag_library, Only: f01fkf, nag_wp, x04daf
!     .. Implicit None Statement ..
      Implicit None
!     .. Parameters ..
      Integer, Parameter               :: nin = 5, nout = 6
!     .. Local Scalars ..
      Integer                          :: i, ifail, lda, n
      Character (4)                    :: fun
      Character (20)                   :: fun_name
!     .. Local Arrays ..
      Complex (Kind=nag_wp), Allocatable :: a(:,:)
!     .. Executable Statements ..
      Write (nout,*) 'F01FKF Example Program Results'
      Write (nout,*)
!     Skip heading in data file
      Read (nin,*)
      Read (nin,*) n, fun

      lda = n
      Allocate (a(lda,n))

!     Read A from data file
      Read (nin,*)(a(i,1:n),i=1,n)

!     Find f( A )
      ifail = 0
      Call f01fkf(fun,n,a,lda,ifail)

!     Print solution
      Write (fun_name,Fmt='(3(A))') 'F(A) = ', fun, '(A)'
      Write (nout,*)

      ifail = 0
      Call x04daf('G','N',n,n,a,lda,fun_name,ifail)

    End Program f01fkfe
